# Borders scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    i = string.find(source, "class=\"book_summary\"")

    if i == -1:
        return


    # Find Image
    i = string.find(source, "class=\"book_thumbnail\"")

    if i != -1:
        image = searchForPlus(source, "class=\"book_thumbnail\"")
        image = searchForPlus(image, " src='")
        i = string.find(image, "'")
        image = stripText(image[0:i])
        i = string.find(image, "placeholder")

        if i == -1:
            aw.setImage1(image)


    # Find Title
    title = searchForPlus(source, "class=\"book_summary\"")
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)


    # Find Artist
    i = string.find(source, "class=\"author_name\"")

    if i != -1:
        artist = searchForPlus(source, "class=\"author_name\"")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])

        if artist == "Compact Disc":
            artist = "Various Artists"

    aw.setArtist(artist)


    # Find Format
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        format = searchForPlus(source, "class=\"pages\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.rfind(format, ",")

        if i != -1:
            format = stripText(format[0:i])

        aw.setFormat(format);


    # Find Publisher & date
    i = string.find(source, "class=\"publisher")

    if i != -1:
        label = searchForPlus(source, "class=\"publisher")
        label = searchForPlus(label, ">")
        i = string.find(label, "</div>")
        label = stripText(label[0:i])

        # Find Publication Date
        i = string.rfind(label, "<br>")

        if i != -1:
            date = stripText(label[i+4:])
            label = stripText(label[0:i])

            aw.setReleaseDate(date)

        aw.setLabel(label)


    # Find Value (Price)
    tag = "class=\"sale_price\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"list_price\""
        i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find List Price
    i = string.find(source, "class=\"list_price\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"list_price\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        aw.setListPrice(listprice)


    # Find UPC
    i = string.find(source, ">UPC:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC:<")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"review_about\"")

    if i != -1:
        info = searchForPlus(source, "class=\"review_about\"")
        info = searchForPlus(info, "</div>")
        i = string.find(info, "</div>")
        info = stripText(info[0:i])

        while (searchFor(info, "align=\"justify\"") != None):
            info = searchForPlus(info, "align=\"justify\"")
            info = searchForPlus(info, ">")
            i = string.find(info, "</p>")
            comment = stripText(info[0:i])
            comments = appendComment(comments, comment)

    i = string.rfind(source, "class=\"review_header\"")

    if i != -1:
        info = stripText(source[i:])
        info = searchForPlus(info, ">")
        info = searchForPlus(info, "</div>")
        i = string.find(info, "</div>")
        comment = stripText(info[0:i])
        i = string.find(comment, "<div>")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    i = string.find(comments, "See All Critics' Reviews")

    if i != -1:
        comments = stripText(comments[0:i])

    aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, ">Track list<")

    if i != -1:
        i = string.find(source, ">See All Tracks")

        if i != -1:
            url = stripText(source[i-150:])
            url = searchForPlus(url, "href=\"")
            i = string.find(url, "\">")
            url = stripText(url[0:i])
            url = string.replace(url, "&amp;", "&")
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents(url)

            try:
                t2 = open("trace2.html", "w")
                t2.write(source)
                t2.close()
            except:
                print "Unable to create trace2.html"

        disks = searchForPlus(source, ">Track list<")
        i = string.find(disks, "\n</div>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        trackList = []
        artistList = []
        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            diskid = "%02d" % diskCount

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            trackNum = 0

            while (searchFor(tracks, "<td width=\"350\">") != None):
                trackNum = trackNum + 1
                tracks = searchForPlus(tracks, "<td width=\"350\">")
                tracks = searchForPlus(tracks, ".")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.find(title, " - ")
                artist = ""

                if i != -1:
                    if title[i+3:i+4] != "(":
                        artist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackNum, title, artist=artist)

            tracks = tracks[1:]

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
