# CD Baby music scrpaer
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Find Category
    i = string.find(source, "itemprop=\"genre\"")

    if i != -1:
        category = searchForPlus(source, "itemprop=\"genre\"")
        category = searchForPlus(category, "content=\"")
        i = string.find(category, "\"")
        aw.setCategory1(stripText(category[0:i]))


    # Find Release date
    i = string.find(source, "itemprop=\"datePublished\"")

    if i != -1:
        date = searchForPlus(source, "itemprop=\"datePublished\"")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        aw.setReleaseDate(stripText(date[0:i]))


    # Find Image
    i = string.find(source, "itemprop=\"image\"")

    if i != -1:
        image = searchForPlus(source, "itemprop=\"image\"")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = "http:" + stripText(image[0:i])

        i = string.find(image, "music-no-image")

        if i == -1:
            aw.setImage1(image)


    # Find Title
    i = string.find(source, "id=\"album-page-album\"")

    if i != -1:
        title = searchForPlus(source, "id=\"album-page-album\"")
        title = searchForPlus(title, "Title\">")
        i = string.find(title, "<")
        aw.setTitle(stripText(title[0:i]))


    # Find Artist
    i = string.find(source, "id=\"album-page-artist\"")

    if i != -1:
        artist = searchForPlus(source, "id=\"album-page-artist\"")
        artist = searchForPlus(artist, "href=\"")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)


    # Find UPC
    i = string.find(source, "id=\"album-page-copyright\"")

    if i != -1:
        upc = searchForPlus(source, "id=\"album-page-copyright\"")
        i = string.find(upc, "</span")
        upc = stripText(upc[0:i])

        i = string.rfind(upc, "(")

        if i != -1:
            upc = stripText(upc[i+1:])
            i = string.find(upc, ")")
            upc = stripText(upc[0:i])
            aw.setUPC(upc)


    # Find Label
    i = string.find(source, "id=\"album-page-copyright\"")

    if i != -1:
        label = searchForPlus(source, "id=\"album-page-copyright\"")
        i = string.find(label, "</span")
        label = stripText(label[0:i])

        i = string.rfind(label, " / ")

        if i != -1:
            label = stripText(label[i+3:])
            i = string.find(label, "<")
            label = stripText(label[0:i])

            i = string.rfind(label, "(")

            if i != -1:
                label = stripText(label[0:i])

            aw.setLabel(label)


    # Find Value
    i = string.find(source, ">Buy CD")

    if i != -1:
        value = searchForPlus(source, ">Buy CD")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        aw.setItemValue(stripText(value[0:i]))

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())
    else:
        i = string.find(source, ">Buy MP3")

        if i != -1:
            value = searchForPlus(source, ">Buy MP3")
            value = searchFor(value, "$")
            i = string.find(value, "<")
            aw.setItemValue(stripText(value[0:i]))

            aw.setPurchasePrice(aw.getItemValue())
            aw.setPurchaseDate(Date())
            aw.setPurchasePlace(aw.getSource())


    # Find Tracks
    i = string.find(source, "class=\"track-table\"")

    if i != -1:
        source = searchForPlus(source, "class=\"track-table\"")
        source = searchFor(source, "</tr>")
        i = string.find(source, "</table>")
        disks = stripText(source[0:i+6])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "</dl>")
            tracks = stripText(disks[0:i])
            trackNum = 0

            while (searchFor(tracks, "class=\"track-title\"") != None):
                tracks = searchForPlus(tracks, "class=\"track-title\"")
                tracks = searchForPlus(tracks, ".")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])
                i = string.find(track, ".")
                track = stripText(track[i+1:])
                
                trackNum = trackNum + 1

                artist = ""
                i = string.find(track, " - Not used anymore")

                if i != -1:
                    artist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                time = ""
                i = string.find(tracks, "_lblTrackTime_")

                if i != -1:
                    tracks = searchForPlus(tracks, "_lblTrackTime_")
                    tracks = searchForPlus(tracks, "\">")
                    i = string.find(tracks, "<")
                    time = stripText(tracks[0:i])
    
                aw.setTrack(diskCount, trackNum, track, artist=artist, time=time)


    # Find Comments
    i = string.find(source, "class=\"album-notes\"")

    if i != -1:
        comment = searchForPlus(source, "class=\"album-notes\"")
        comment = searchForPlus(comment, "<span ")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "<br /></span>")
        comment = stripText(comment[0:i])

        if comment.startswith("to write a review") == 1:
            comment = ""

        i = string.find(comment, "</div><br />")

        if i != -1:
            comment = stripText(comment[0:i])

        aw.setProductInfo(comment)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
