# Loot.co.za music scraper
#
# Copyright  1999-2013 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("R")

    i = string.find(source, ">Showing ")

    if i != -1:
        source = searchForPlus(source, ">Showing ")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText("http://www.loot.co.za" + source[0:i])
        url = string.replace(url, "&amp;", "&")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Find Image
    imageTag = "class=\"fancybox\""
    i = string.find(source, imageTag)

    if i != -1:
        images = searchForPlus(source, imageTag)
        image = searchForPlus(images, "<img src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image[i:].startswith("' width=1 height=1") == 1:
            image = ""
        else:
            if image.startswith("http") == 0:
                image = "http://www.loot.co.za" + image

            aw.setImage1(image)
            aw.setLargeImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"productOverview\"")
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    aw.setTitle(title)


    # Find Artist
    i = string.find(source, "<h2>")

    if i != -1:
        artist = searchForPlus(source, "<h2>")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)


    # Find List Price
    i = string.find(source, "<em>List price:</em>")

    if i != -1:
        source = searchForPlus(source, "<em>List price:</em>")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        aw.setListPrice(value)


    # Find Price
    i = string.find(source, "<em>Loot Price:</em>")

    if i != -1:
        source = searchForPlus(source, "<em>Loot Price:</em>")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Comments
    i = string.find(source, "target=\"_top\">Description<")

    if i != -1:
        source = searchForPlus(source, "target=\"_top\">Description<")
        source = searchForPlus(source, "class=\"tab-body\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<h")
        comments = stripText(source[0:i])
        aw.setProductInfo(comments)


    # Find Label
    source = searchForPlus(source, "class=\"tab-body\"")
    i = string.find(source, ">Label:<")

    if i != -1:
        label = searchForPlus(source, ">Label:<")
        label = searchForPlus(label, "<td>")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Release date
    i = string.find(source, ">Release&nbsp;date:<")

    if i != -1:
        date = searchForPlus(source, ">Release&nbsp;date:<")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find Format
    i = string.find(source, ">Format<")

    if i != -1:
        format = searchForPlus(source, ">Format<")
        format = searchForPlus(format, "alt='")
        i = string.find(format, "'")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Category
    i = string.find(source, ">Categories:<")

    if i != -1:
        category = searchForPlus(source, ">Categories:<")
        category = searchForPlus(category, "<a href=\"")
        category = searchForPlus(category, "<a href=\"")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        aw.setCategory1(category)


    # Find Tracks
    i = string.find(source, "<div class=\"tab-body\"")

    if i != -1:
        source = searchForPlus(source, "<div class=\"tab-body\"")
        i = string.find(source, "</div>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disk") == -1:
            disks = ">Disk 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disk ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disk ")
            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            trackIndex = 1

            while (searchFor(tracks, "<tr>") != None):
                tracks = searchForPlus(tracks, "<tr>")
                tracks = searchForPlus(tracks, "<td>")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.find(title, " - ")
                artist = ""

                if i != -1:
                    artist = stripText(title[i+3:])
                    title = stripText(title[0:i])

                aw.setTrack(diskCount, trackIndex, title, artist=artist)


    # Find user rating
    i = string.find(source, ">Average Customer Review:<")

    if i != -1:
        temp = searchForPlus(source, ">Average Customer Review:<")
        temp = searchForPlus(temp, "<img src=\"")
        i = string.find(temp, "\"")
        temp = stripText(temp[0:i])
        i = string.rfind(temp, "/")

        if i != -1:
            temp = stripText(temp[i+1:])

        i = string.find(temp, ".")

        if i != -1:
            temp = stripText(temp[0:i])

        if temp.startswith("stars-") == 1:
            temp = searchForPlus(temp, "stars-")

        temp = string.replace(temp, "-", ".")

        if temp != "":
            rating = temp + " Stars"








try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
