# bibliotek.dk scraper
#
# Copyright  1999-2013 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment
from    rwsupport import calcISBN10CheckDigit

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Denmark")
    rw.setLanguage("Danish")


    http = HTTPConnection()
    http.deleteCookies();                

    i = string.find(source, "class=\"mainitem\"")
        
    if i == -1:
        print "Not found"
        # Not found
        return

    # Main extraction
    # Find ISBN
    i = string.find(source, ">Du sgte p:")
    print "I=",i

    if i != -1:
        isbn = searchForPlus(source, ">Du sgte p:")
        isbn = searchForPlus(isbn, "&#61;")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    source = searchFor(source, "class=\"mainitem\"")
    source = searchFor(source, "[+]")


    # Find Title
    title = searchForPlus(source, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    i = string.find(source, ";field1=")

    if i != -1:
        author = searchForPlus(source, ";field1=")
        author = searchForPlus(author, "\">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        rw.setAuthor(author)


    # Find Image
    i = string.find(source, ".img\")")

    if i != -1:
        image = searchForPlus(source, ".img\")")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        rw.setImage1(image)


    # Find Large Image
    i = string.find(source, ".new\")")

    if i != -1:
        image = searchForPlus(source, ".new\")")
        image = searchFor(image, "http:")
        i = string.find(image, "'")
        image = stripText(image[0:i])

        rw.setLargeImage1(image)


    # Find Language
    i = string.find(source, ">Sprog:")

    if i != -1:
        lang = searchForPlus(source, ">Sprog:")
        i = string.find(lang, "<")
        lang = stripText(lang[0:i])

        rw.setLanguage(lang)


    # Find Publisher
    i = string.find(source, "title=\"BOG\" /> ")

    if i != -1:
        date = ""
        publisher = searchForPlus(source, "title=\"BOG\" /> ")
        publisher = searchForPlus(publisher, "BOG:")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.rfind(publisher, ", ")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])

            i = string.find(date, " ")

            if i != -1:
                date = stripText(date[0:i])

        rw.setPublisher(publisher)
        rw.setReleaseDate(date)


    # Find Copyright date
    i = string.find(source, ">Originaludgave:")

    if i != -1:
        date = searchForPlus(source, ">Originaludgave:")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setCopyrightDate(date)


    # Find Pages
    i = string.find(source, "sider<")

    if i != -1:
        pages = stripText(source[i-10:])
        pages = searchForPlus(pages, "/>")
        i = string.find(pages, " ")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Series
    i = string.find(source, ">Serie:")

    if i != -1:
        series = searchForPlus(source, ">Serie:")
        series = searchForPlus(series, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find Keywords
    info = ""
    i = string.find(source, ">Emne: <")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, ">Emne: <")
        i = string.find(temp, "<br/>")
        info = stripText(temp[i+5:])
        temp = stripText(temp[0:i])

        while (searchFor(temp, "class='lnk'") != None):
            temp = searchForPlus(temp, "class='lnk'")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])

            if keywords == "":
                keywords = keyword
            else:
                keywords = keywords + ", " + keyword

        rw.setKeywords(keywords)

        i = string.find(info, "</div>")
        info = stripText(info[0:i])
        info = string.replace(info, "[...]", "")
        info = string.replace(info, "  ", " ")
        rw.setProductInfo(info)




def cleanupData(str):
    str = string.replace(str, "\xC3\x84", "\xC4")
    str = string.replace(str, "\xC3\x85", "\xC5")
    str = string.replace(str, "\xC3\x96", "\xD6")
    str = string.replace(str, "\xC3\xA4", "\xE4")
    str = string.replace(str, "\xC3\xA5", "\xE5")
    str = string.replace(str, "\xC3\xB6", "\xF6")
    str = string.replace(str, "\xC5\x8D", "\xF6")
    return str    




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
