# bol.nl.com scraper
#
# copied from various sources
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date



def translate_text(str):
    str = string.replace(str, "\xC2\xAE", "")
    str = string.replace(str, "\xC3\xA7", "")
    str = string.replace(str, "\xC3\xA8", "")
    str = string.replace(str, "\xC3\xA9", "")
    str = string.replace(str, "\xC3\xAB", "")
    str = string.replace(str, "\xC3\xAD", "")
    str = string.replace(str, "\xC3\xAF", "")
    str = string.replace(str, "\xC5\xB8", "")
    str = string.replace(str, "\xC5\xBD", "")
    str = string.replace(str, "\xE2\x80\x93", "-")
    str = string.replace(str, "\xE2\x80\x98", "'")
    str = string.replace(str, "\xE2\x80\x99", "'")
    return string.strip(str);


def extract(source):
    # Defaults
    rw.setPublicationPlace("Netherlands")
    rw.setLanguage("Dutch")
    rw.setCurrencySymbol("")

    # is this the search page or the detail page?
    i = string.find (source, "gevonden voor \"")

    if i != -1: 
        source = searchForPlus(source, "class=\"imgwrap_thumb\"")
        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = "http://www.bol.com" + stripText(source[0:i]);

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(source)
        t.close()

    #
    # this should be the product page



    # Find List price
    i = string.find(source, "Adviesprijs:")

    if i != -1:
        listprice = searchForPlus(source, "bol.com prijs:")
        # now the euro symbol - stored as #8364;&nbsp;PRICE
        listprice = searchForPlus (listprice, "8364; ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find Image
    imageTag = "name=\"product_images\""
    i = string.find(source, imageTag)

    if i != -1:
        image = searchForPlus(source, imageTag)
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image[i:].startswith("xxx") == 1:
            image = ""
        else:
            rw.setImage1(image)
            rw.setLargeImage1(image)
 

    # Find Title
    tag = "<h1 class=\"pdp-header__title bol_header\""
    source = searchForPlus(source, tag)

    if source == None:
        print "can't find title"
        return

    source = searchForPlus(source, "\" >")
    i = string.find(source, "<");
    title = stripText(source[0:i])

    if title == "Geen zoekresultaat":
        title = ""
        print "can't find title"
        return

    title = translate_text(title)
    rw.setTitle(title)


    # Find Author
    author = ""
    authorList = []

    i = string.find(source, "Auteur:")

    if i != -1:
        source = searchForPlus(source, "Auteur:")
        i = string.find(source, "</div>")
        authors = stripText(source[0:i])

        while (searchFor(authors, " href") != None):
            authors = searchForPlus(authors, " href")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<");
            author = stripText(authors[0:i])
            author = stripText(author)
            author = translate_text(author)
            authorList.append(author)

        rw.setAuthors(authorList)

    # Find Publisher
    i = string.find(source, "Uitgever:")

    if i != -1:
        publisher = searchForPlus(source, "Uitgever:")
        publisher = searchForPlus(publisher, "\" >")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        publisher = translate_text(publisher)
        rw.setPublisher(publisher)

    # Find Pages
    i = string.find(source, "pagina's")

    if i != -1:
        pages = stripText(source[i-15:])
        i = string.find(pages, "&")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Comments 
    i = string.find(source, "itemprop=\"description\"")

    if i != -1:
        comments = searchFor(source, "itemprop=\"description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        comments = translate_text(comments)

        rw.setProductInfo(comments)


    # Find Format
    source = searchForPlus(source, ">Productspecificaties<")
    tag= "bindwijze"
    i = string.find(source, tag)

    if i != -1:
        format = searchForPlus(source, tag)
        format = searchForPlus(format, "title=\"")
        i = string.find(format, "\"")
        format = stripText(format[0:i])
        rw.setFormat(format)

    # Find Publication date
    i = string.find(source, "Verschijningsdatum")

    if i != -1:
        date = searchForPlus(source, "Verschijningsdatum")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        date = translate_text(date)
        rw.setReleaseDate(date)

    # Find Language
    i = string.find(source, " Taal")

    if i != -1:
        language = searchForPlus(source, " Taal")
        language = searchForPlus(language, "\">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        language = translate_text(language)
        rw.setLanguage(language)

    # Find ISBN
    i = string.find(source, " ISBN")

    if i != -1:
        isbn = searchForPlus(source, " ISBN")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        isbn = translate_text(isbn)
        rw.setISBN(isbn)


    # Find Price
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchForPlus(source, "itemprop=\"price\"")
        value = searchForPlus(value, "content=\"")
        i = string.find(value, "\"")
        value = stripText(value[0:i])
        value = "" + value
        value = string.replace(value, "\xE2\x82\xAC", "")

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Dimensions
    i = string.find(source, "Afmetingen")

    if i != -1:
        dimensions = searchForPlus(source, "Afmetingen")
        dimensions = searchForPlus(dimensions, "\">")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])
        rw.setDimensions(dimensions)


    # Find Weight
    i = string.find(source, "Gewicht")

    if i != -1:
        weight = searchForPlus(source, "Gewicht")
        weight = searchForPlus(weight, "\">")
        i = string.find(weight, "<")
        weight = stripText(weight[0:i])
        rw.setWeight(weight)


    # Find Category
    i = string.find(source, "Categorie")

    if i != -1:
        category = ""
        categories = searchForPlus(source, "Categorie")
        categories = searchForPlus(categories, "<ul ")
        i = string.find(categories, "</ul>")
        categories = stripText(categories[0:i])
        categories = translate_text(categories)
        ccount = 1

        while (searchFor(categories, "<a href") != None):
            categories = searchForPlus(categories, "<a href")
            categories = searchForPlus(categories, "\">")
            i = string.find(categories, "<");
            category = stripText(categories[0:i])

            if ccount == 1:
                rw.setCategory1(category)
            elif ccount == 2:
                rw.setCategory2(category)
            else:
                rw.setCategory3(category)
                break

            ccount = ccount + 1







try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
