# Borders scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")


    # Main extraction
    i = string.find(source, "class=\"tdp-body\"")

    if i == -1:
        return

    source = searchForPlus(source, "class=\"tdp-body\"")

    # Find Image
    i = string.find(source, "class=\"jtip prod-item\"")

    if i != -1:
        image = searchForPlus(source, "class=\"jtip prod-item\"")
        image = searchForPlus(image, " src='")
        i = string.find(image, "'")
        image = stripText(image[0:i])
        i = string.find(image, "placeholder")

        if i == -1:
            rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"titleheader\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    rw.setTitle(stripText(source[0:i]))


    # Find Format
    i = string.find(source, "class=\"titleformat\"")

    if i != -1:
        format = searchForPlus(source, "class=\"titleformat\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        format = string.replace(format, "[", "")
        format = string.replace(format, "]", "")
        rw.setFormat(format)


    # Find Author
    i = string.find(source, "class=\"authors\"")

    if i != -1:
        authorList = []
        authors = searchForPlus(source, "class=\"authors\"")
        authors = searchForPlus(authors, "class=\"enhanced-title\"")
        i = string.find(authors, "</div>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)

        rw.setAuthors(authorList)


    # Find Pages
    i = string.find(source, "class=\"pages\"")

    if i != -1:
        pages = searchForPlus(source, "class=\"pages\"")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "&nbsp;")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Publisher
    i = string.find(source, ">Publisher:")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Publication Date
    i = string.find(source, ">Date:")

    if i != -1:
        date = searchForPlus(source, ">Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        date = stripText(string.replace(date, "&nbsp;", " "))
        rw.setReleaseDate(date)


    #Find Category
    i = string.find(source, "class=\"subject\"")

    if i != -1:
        category = searchForPlus(source, "class=\"subject\"")
        category = searchForPlus(category, "</b>")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        i = string.rfind(category, " - ")

        if i != -1:
            category = stripText(category[i+3:])

        rw.setCategory1(category)


    # Find Price
    tag = "class=\"offerPrice"
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"enhanced_listprice\""
        i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value[0:i])

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find List Price
    i = string.find(source, "class=\"enhanced_listprice\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"enhanced_listprice\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])

        if listprice != "N/A":
            rw.setListPrice(listprice)


    # Find ISBN
    i = string.find(source, ">ISBN13:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN13:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Find Comments
    comments = ""
    i = string.find(source, "class=\"about-product-ctw\"")

    if i != -1:
        source = searchForPlus(source, "class=\"about-product-ctw\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<div ")
        info = stripText(source[0:i])

        i = string.find(info, "more</a>")

        if i != -1:
            info = stripText(info[0:i])

        i = string.find(info, "Back to Title Details</a>")

        if i != -1:
            info = stripText(info[0:i])

    rw.setProductInfo(info)




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
