# half.com scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")


    #Check for not found
    i = string.find(source, "We were unable to find any matches for ")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")

    # Find List price
    i = string.find(source, "class=\"pdplistpricestyle\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"pdplistpricestyle\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])

        i = string.find(listprice, "(")

        if i != -1:
            listprice = stripText(listprice[0:i])

        rw.setListPrice(listprice)


    # Find New price
    i = string.find(source, "name=\"itemlist_BRAND_NEW\"")

    if i != -1:
        try:
            newprice = searchForPlus(source, "name=\"itemlist_BRAND_NEW\"")
            newprice = searchFor(newprice, "$")
            
            i = string.find(newprice, "<")
            
            if i != -1:
                newprice = stripText(newprice[0:i])
        except:
            newprice = ""

        if newprice != "":
            rw.setNewPrice(newprice)


    # Find Used price
    i = string.find(source, "name=\"itemlist_LIKE_NEW\"")

    if i != -1:
        try:
            usedprice = searchForPlus(source, "name=\"itemlist_LIKE_NEW\"")
            usedprice = searchFor(usedprice, "$")
            
            i = string.find(usedprice, "<")
            
            if (i != -1):
                usedprice = stripText(usedprice[0:i])
        except:
            usedprice = ""

        if usedprice != "":
            rw.setUsedPrice(usedprice)


    # Find Image
    i = string.find(source, ".ebayimg.")

    if i != -1 and i < 15000:
        source = stripText(source[i-50:])
        source = searchFor(source, "\"http:")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "593221")

        if i == -1:
            rw.setImage1(image)


    # Find Title
    title = searchForPlus(source, "class=\"pdppagetitle\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    rw.setTitle(stripText(title[0:i]))


    # Find Author
    authorList = []
    i = string.find(source, ">Author:")

    if i != -1:
        authors = searchForPlus(source, ">Author:")
        i = string.find(authors, "</span>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "\">") != None):
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])

            if author == "":
                continue;

            authorList.append(author)

        rw.setAuthors(authorList)


    # Find illustrator
    i = string.find(source, ">Illustrated by:")

    if i != -1:
        authors = searchForPlus(source, ">Illustrated by:")
        i = string.find(authors, "\n")
        authors = stripText(authors[0:i])
        authors = searchForPlus(authors, "href")
        authors = searchForPlus(authors, "\">")
        i = string.find(authors, "<")
        author = stripText(authors[0:i])
        rw.setIllustrator(author)


    # Find Price
    i = string.find(source, "class=\"beststyle\"")

    if i != -1:
        value = searchForPlus(source, "class=\"beststyle\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        rw.setFormat(stripText(format[0:i]))


    # Find ISBN
    i = string.find(source, ">ISBN-10:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN-10:<")
        isbn = searchForPlus(isbn, "href")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if (i != -1):
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        rw.setPublisher(stripText(publisher[0:i]))


    # Find Pages
    i = string.find(source, " pages<")

    if i != -1:
        pages = source[i-15:]
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        # Just the numbers
        i = string.find(pages, "pages")

        if i != -1:
            pages = stripText(pages[0:i])

        rw.setPages(pages)


    # Find Comments
    comments = ""
    i = string.find(source, "<b>Synopsis</b>")

    if i != -1:
        comment = searchFor(source, "<b>Synopsis</b>")
        comment = searchForPlus(comment, "<b>")
        i = string.find(comment, "<br/><br/>")
        comments = stripText(comment[0:i])

    i = string.find(source, "<b>Industry Reviews<")

    if i != -1:
        comment = searchFor(source, "<b>Industry Reviews<")
        comment = searchForPlus(comment, "<b>")
        i = string.find(comment, "<br/><br/>")
        comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    if comments != "":
        rw.setProductInfo(comments)


    # Find Dimensions
    height = ""
    width = ""
    thickness = ""

    i = string.find(source, ">Height:<")

    if i != -1:
        height = searchForPlus(source, ">Height:<")
        height = searchForPlus(height, "\">")
        i = string.find(height, "<")
        height = stripText(height[0:i])

    i = string.find(source, ">Width:<")

    if i != -1:
        width = searchForPlus(source, ">Width:<")
        width = searchForPlus(width, "\">")
        i = string.find(width, "<")
        width = stripText(width[0:i])

    i = string.find(source, ">Thickness:<")

    if i != -1:
        thickness = searchForPlus(source, ">Thickness:<")
        thickness = searchForPlus(thickness, "\">")
        i = string.find(thickness, "<")
        thickness = stripText(thickness[0:i])

    if height != "" and width != "":
        rw.setDimensions(height + " x " + width+ " x " + thickness)


    # Find Weight
    i = string.find(source, ">Weight:<")

    if i != -1:
        weight = searchForPlus(source, ">Weight:<")
        weight = searchForPlus(weight, "\">")
        i = string.find(weight, "<")
        rw.setWeight(stripText(weight[0:i]))


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
