# Internet Book Store (IT) scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("Italia")
    rw.setLanguage("Italian")
    rw.setCurrencySymbol("")

    # Find List Price
    i = string.find(source, ">EURO")

    if i != -1:
        listprice = searchForPlus(source, ">EURO")
        listprice = searchForPlus(listprice, "Prezzo di copertina EURO")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        listprice = " " + listprice
        rw.setListPrice(listprice)


    # Sometimes ISBN only hidden at top. Try that now,
    # Regular ISBN is at end, I'll try that too, see
    # further down.
    # Find ISBN, first try
    i = string.find(source, "name=\"isbn\"")

    if i != -1:
        isbn = searchForPlus(source, "name=\"isbn\"")
        isbn = searchForPlus(isbn, "value=\"")
        i = string.find(isbn, "\"")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)

    # Find Image
    i = string.find(source, "rel=\"image_src\"")

    if i != -1:
        source = searchForPlus(source, "rel=\"image_src\"")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        io = http.getContents(image)
        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(io)
        t.close()

        i = string.find(io, "<BASE HREF=\"")

        if i != -1:
            io = searchForPlus(io, "<BASE HREF=\"")
            i = string.find(io, "\"")
            image = stripText(io[0:i])

        rw.setImage1(image)

    # Find Title
    title = ""
    source = searchFor(source, ">Titolo<")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if title == "Libro non presente nel catalogo":
        title = ""
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return

    if title == ("Segnala questo libro a un amico"):
        source = searchFor(source, "td bgcolor=\"#336633")
        source = searchForPlus(source, "><b>")
        i = string.find(source, "</b>")
        title = stripText(source[0:i])

    rw.setTitle(title)


    # Find Author
    i = string.find(source, ">Autore<")

    if i != -1:
        source = searchForPlus(source, ">Autore<")
        source = searchForPlus(source, "><b>")
        i = string.find(source, "</b>")
        authors = stripText(source[0:i]) + ":"
        authorList = []

        while (searchFor(authors, ":") != None):
            i = string.find(authors, ":")
            author = stripText(authors[0:i])
            authorList.append(author)
            authors = searchForPlus(authors, ":")

        rw.setAuthors(authorList)


    # Find Price
    i = string.find(source, ">Prezzo<")

    if i != -1:
        source = searchForPlus(source, ">Prezzo<")
        source = searchForPlus(source, "&euro;")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        value = " " + value
        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())

    # Find Pages, Format
    i = string.find(source, ">Dati<")

    if i != -1:
        source = searchForPlus(source, ">Dati<")
        source = searchForPlus(source, "\">")
        i = string.find(source, ",")
        date = stripText(source[0:i])
        source = searchForPlus(source, ",")
        i = string.find(source, "p.")
        pages = stripText(source[0:i-1])
        rw.setPages(pages)

        source = stripText(source[i:])

    i = string.find(source, "ill.,")

    if i == -1:
        i = string.find(source, "p.,")

    if i != -1:
        source = stripText(source[i:])
        source = searchForPlus(source, ",")
        i = string.find(source, "</")
        format = stripText(source[0:i])
        rw.setFormat(format)


    # Find Publisher
    i = string.find(source, "ExactPublisher")

    if i != -1:
        source = searchFor(source, "ExactPublisher")
        source = searchForPlus(source, "><b>")
        i = string.find(source, "</b>")
        publisher = stripText(source[0:i])
        rw.setPublisher(publisher)


    # Find Series
    i = string.find(source, "EXACTSERIES")

    if i != -1:
        source = searchFor(source, "EXACTSERIES")
        source = searchForPlus(source, "><b>")
        i = string.find(source, "</b>")
        series = stripText(source[0:i])
        rw.setSeries(series)


    # Find Comments
    comments = ""
    i = string.find(source, "<b>In sintesi</b>")
    y = string.find(source, "<b>Descrizione</b>")

    if i != -1:
        source = searchForPlus(source, "<b>In sintesi</b>")

    if y != -1:
        source = searchForPlus(source, "<b>Descrizione</b>")
 
    if y != -1 or i != -1: 
        source = searchForPlus(source, "class=\"tcorpotesto\">")
        i = string.find(source, "</span>")  
        comments = stripText(source[0:i])

        i = string.find(comments, "</font><p>")

        if i != -1:
            comments = stripText(comments[0:i])

        comments = "Descrizione<br>" + comments

    i = string.find(source, "<b>La recensione di IBS</b>")
 
    if i != -1: 
        source = searchForPlus(source, "<b>La recensione di IBS</b>")
        source = searchForPlus(source, "class=\"tcorpotesto\">")
        i = string.find(source, "</span>")  
        comment = stripText(source[0:i])

        i = string.find(comment, "</font><p>")

        if i != -1:
            comment = stripText(comment[0:i])

        comment = "La recensione di IBS<br>" + comment
        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)


    # Find ISBN
    source = searchForPlus(source, "ISBN=")

    if (source == None):
        return

    i = string.find(source, "&")
    isbn = stripText(source[0:i])
    rw.setISBN(isbn)


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
