# Library of Congress scraper (New site as of May 2014)
#
# Copyright  1999-2014 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")


    # Looking for the ISBN I searched for. LOC
    # can return multiple ISBNs for the same listing
    # want to get the correct format.
    searchISBN = ""
    i = string.find(source, "Guided Search = (")

    if i != -1:
        searchISBN = searchForPlus(source, "Guided Search = (")
        i = string.find(searchISBN, ")")
        searchISBN = stripText(searchISBN[0:i])

        if len(searchISBN) < 10:
            searchISBN = ""
        else:
            # ISBN 10 excl check digit
            searchISBN = stripText(searchISBN[3:i])
            searchISBN = stripText(searchISBN[0:len(searchISBN)-1])


    # Looking for duplicate LCCN matches, take first one
    i = string.find(source, "id=\"search-results\"")

    if i != -1:
        source = searchForPlus(source, "id=\"search-results\"")
        count = searchForPlus(source, ">Titles List:")
        count = searchForPlus(source, "of ")
        i = string.find(count, "&")
        count = stripText(count[0:i])

        try:
            rw.setResultCount(int(count))
        except:
            print "Unable to set result count"

        i = string.find(source, "\"Book Icon\"")

        if i != -1:
            source = searchForPlus(source, "\"Book Icon\"")

        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://catalog.loc.gov/vwebv/" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Author (it is possible to have no author line, in
    # which case I will assume "Various", i.e. a collection with no
    # specific author
    authorList = []
    i = string.find(source, ">Personal name<")

    if i != -1:
        authors = searchForPlus(source, ">Personal name<")
        i = string.find(authors, "</ul>")
        authors = stripText(authors[0:i])
        author = searchForPlus(authors, "href=\"")
        author = searchForPlus(authors, "dir=\"ltr\"")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        # Remove , pseud if present.
        if (string.count(author, ",") > 1):
            i = string.find(author, ",")
            i = string.find(author, ",", i+1)
            author = author[0:i]

        # Remove trailing period, if present
        i = string.rfind(author, ".")

        if (i != -1):
            x = i - 2

            if (x >= 2):
                if (author[x:x+1] != ' '):
                    if (len(author) == (i + 1)):
                        author = author[0:i]
            else:
                if (len(author) == (i + 1)):
                    author = author[0:i]

        if author[len(author) - 1] == ",":
            author = author[0: len(author)-1]

        authorList.append(rw.convertName(author))


    i = string.find(source, ">Related names<")

    if i != -1:
        authors = searchForPlus(source, ">Related names<")
        i = string.find(authors, "</ul>")
        authors = stripText(authors[0:i])
        author = searchForPlus(authors, "href=\"")
        author = searchForPlus(authors, "dir=\"ltr\"")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        # We do need to get related names as sometimes this is the only
        # author information. But I also get some strange data at times
        # (978-0-553-56526-3). If it doesn't look like an author, skip
        i = string.find(author, ",")

        if i != -1:
            # Looks like last, first
            # Remove , pseud if present.
            if (string.count(author, ",") > 1):
                i = string.find(author, ",")
                i = string.find(author, ",", i+1)
                author = author[0:i]

            # Remove trailing period, if present
            i = string.rfind(author, ".")

            if (i != -1):
                x = i - 2

                if (x >= 2):
                    if (author[x:x+1] != ' '):
                        if (len(author) == (i + 1)):
                            author = author[0:i]
                else:
                    if (len(author) == (i + 1)):
                        author = author[0:i]

            if author[len(author) - 1] == ",":
                author = author[0: len(author)-1]

            authorList.append(rw.convertName(author))

    rw.setAuthors(authorList)


    # Find Title
    title = searchForPlus(source, ">Main title<")
    title = searchForPlus(title, "dir=\"ltr\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    i = string.find(title, " / ")

    if i != -1:
        title = stripText(title[0:i])

    # Remove Translated by, if present.
    i = string.find(title, ". Translated")

    if (i != -1):
        title = title[0:i]

    # Remove trailing period, if present
    if title.endswith(".") == 1:
        title = title[0:len(title)-1]

    rw.setTitle(title)


    # Find Place
    i = string.find(source, ">Published/")

    if i != -1:
        attrs = searchForPlus(source, ">Published/")
        attrs = searchForPlus(attrs, "dir=\"ltr\"")
        attrs = searchForPlus(attrs, ">")
        i = string.find(attrs, "<")
        attrs = stripText(attrs[0:i])
        i = string.find(attrs, " : ")

        if i != -1:
            rw.setPublicationPlace(stripText(attrs[0:i]))
            attrs = stripText(attrs[i+2:])
        else:
            i = string.find(attrs, "., ")

            if i != -1:
                rw.setPublicationPlace(stripText(attrs[0:i+1]))
                attrs = stripText(attrs[i+2:])
            else:
                i = string.find(attrs, ", ")

                if i != -1:
                    rw.setPublicationPlace(stripText(attrs[0:i]))
                    attrs = stripText(attrs[i+1:])


        # Find Publisher
        i = string.rfind(attrs, ",")

        if i != -1:
            rw.setPublisher(stripText(attrs[0:i]))
            attrs = stripText(attrs[i+1:])
        else:
            i = string.rfind(attrs, "[")

            if i != -1:
                rw.setPublisher(stripText(attrs[0:i]))
                attrs = stripText(attrs[i+1:])
            else:
                rw.setPublisher(attrs)


        # Find Publication Date
        i = string.find(attrs, ".")

        if i != -1:
            date = stripText(attrs[0:i])
        else:
            date = attrs

        i = string.find(date, "[")

        if i != -1:
            date = stripText(date[i+1:])

        i = string.find(date, "]")

        if i != -1:
            date = stripText(date[0:i])

        # if date in format cyyyy, strip c
        if (len(date) == 5):
            i = string.find(date, "c")

            if i == 0:
                date = stripText(date[1:])
                rw.setCopyrightDate(date)
        
        rw.setReleaseDate(date)


    # Find Pages
    i = string.find(source, ">Description<")

    if i != -1:
        attrs = searchForPlus(source, ">Description<")
        attrs = searchForPlus(attrs, "dir=\"ltr\"")
        attrs = searchForPlus(attrs, ">")
        i = string.find(attrs, "<")
        attrs = stripText(attrs[0:i])
        i = string.find(attrs, "p.")

        if i != -1:
            pages = stripText(attrs[0:i])

            i = string.rfind(pages, " ")

            if i != -1:
                pages = stripText(pages[i:])

            rw.setPages(pages)


        # Find Dimensions
        dimensions = attrs
        i = string.find(dimensions, " cm.")

        if i != -1:
            dimensions = stripText(dimensions[i-5: i+4:])

        i = string.find(dimensions, " ")

        if i != -1:
            dimensions = stripText(dimensions[i:])

        i = string.find(dimensions, ";")

        if i != -1:
            dimensions = stripText(dimensions[i+1:])

        if dimensions == "cm.":
            dimensions = ""

        rw.setDimensions(dimensions)


    # Find ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN<")
        isbn = searchForPlus(isbn, "dir=\"ltr\"")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        # Find format (only look for paperback)
        if string.find(isbn, "pbk") != -1:
            rw.setFormat("Paperback")
        elif string.find(isbn, "paper") != -1:
            rw.setFormat("Paperback")
        else:
            rw.setFormat("Hardcover")

        i = string.find(isbn, " ")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find LOC Call Number
    i = string.find(source, ">LC classification")

    if i != -1:
        callNumber = searchForPlus(source, ">LC classification")
        callNumber = searchForPlus(callNumber, "dir=\"ltr\"")
        callNumber = searchForPlus(callNumber, ">")
        i = string.find(callNumber, "<")
        callNumber = stripText(callNumber[0:i])
        rw.setCallNumber(callNumber)


    # Find Comments
    comments = ""
    i = string.find(source, ">Notes<")

    if i != -1:
        comment = searchForPlus(source, ">Notes<")
        comment = searchForPlus(comment, "dir=\"ltr\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)


    # Find Comments
    i = string.find(source, ">Summary<")

    if i != -1:
        comment = searchForPlus(source, ">Summary<")
        comment = searchForPlus(comment, "dir=\"ltr\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)


    # Find Comments
    i = string.find(source, ">Contents<")

    if i != -1:
        comment = searchForPlus(source, ">Contents<")
        comment = searchForPlus(comment, "dir=\"ltr\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    if comments != "":
        rw.setProductInfo(comments)


    # Find Keywords
    i = string.find(source, ">LC Subjects<")

    if i != -1:
        temp = searchForPlus(source, ">LC Subjects<")
        i = string.find(temp, "</ul>")
        temp = stripText(temp[0:i])
        keywords = ""

        while (searchFor(temp, "href=\"") != None):
            temp = searchForPlus(temp, "href=\"")
            temp = searchForPlus(temp, "dir=\"ltr\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])
            i = string.rfind(keyword, ".")

            if (i != -1):
                keyword = stripText(keyword[0:i])

            if keywords != "":
                keywords = keywords + ", " + keyword
            else:
                keywords = keyword

        rw.setKeywords(keywords)


    # Find Category
    i = string.find(source, ">Form/Genre<")

    if i != -1:
        cat = searchForPlus(source, ">Form/Genre<")
        cat = searchForPlus(cat, "dir=\"ltr\"")
        cat = searchForPlus(cat, ">")
        i = string.find(cat, "<")
        cat = stripText(cat[0:i])

        i = string.rfind(cat, ".")

        if i != -1:
            cat = stripText(cat[0:i])
            
        rw.setCategory1(cat)
    else:
        i = string.find(source, ">Subjects<")

        if i != -1:
            cats = searchForPlus(source, ">Subjects<")
            i = string.find(cats, "</ul>")
            cats = stripText(cats[0:i])
            ccount = 1

            while (searchFor(cats, "href=\"") != None):
                cats = searchForPlus(cats, "href=\"")
                cats = searchForPlus(cats, "dir=\"ltr\"")
                cats = searchForPlus(cats, ">")
                i = string.find(cats, "<")
                cat = stripText(cats[0:i])
                i = string.rfind(cat, ".")

                if i != -1:
                    cat = stripText(cat[0:i])

                if ccount == 1:
                    rw.setCategory1(cat)
                elif ccount == 2:
                    rw.setCategory2(cat)
                else:
                    rw.setCategory3(cat)
                    break

                ccount = ccount + 1


    # Find Series
    i = string.find(source, ">Series<")

    if i != -1:
        series = searchForPlus(source, ">Series<")
        series = searchForPlus(series, "dir=\"ltr\"")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find LCCN
    i = string.find(source, ">LCCN<")

    if i != -1:
        lccn = searchForPlus(source, ">LCCN<")
        lccn = searchForPlus(lccn, "dir=\"ltr\"")
        lccn = searchForPlus(lccn, ">")
        i = string.find(lccn, "<")
        lccn = stripText(lccn[0:i])
        rw.setLCCN(lccn)


    # Find Dewey Number
    i = string.find(source, ">Dewey class no.<")

    if i != -1:
        source = searchForPlus(source, ">Dewey class no.<")
        source = searchForPlus(source, "dir=\"ltr\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        rw.setDewey(stripText(source[0:i]))




def extractPL(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")


    # Find Author (it is possible to have no author line, in
    # which case I will assume "Various", i.e. a collection with no
    # specific author
    authorList = []
    i = string.find(source, ">Personal Name<")

    if i != -1:
        authors = searchForPlus(source, ">Personal Name<")
        i = string.find(authors, "</ul>")
        authors = stripText(authors[0:i])
        author = searchForPlus(authors, "href=\"")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        # Remove , pseud if present.
        if (string.count(author, ",") > 1):
            i = string.find(author, ",")
            i = string.find(author, ",", i+1)
            author = author[0:i]

        # Remove trailing period, if present
        i = string.rfind(author, ".")

        if (i != -1):
            x = i - 2

            if (x >= 2):
                if (author[x:x+1] != ' '):
                    if (len(author) == (i + 1)):
                        author = author[0:i]
            else:
                if (len(author) == (i + 1)):
                    author = author[0:i]

        if author[len(author) - 1] == ",":
            author = author[0: len(author)-1]

        authorList.append(rw.convertName(author))


    i = string.find(source, ">Related names<")

    if i != -1:
        authors = searchForPlus(source, ">Related names<")
        i = string.find(authors, "</ul>")
        authors = stripText(authors[0:i])
        author = searchForPlus(authors, "href=\"")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        # We do need to get related names as sometimes this is the only
        # author information. But I also get some strange data at times
        # (978-0-553-56526-3). If it doesn't look like an author, skip
        i = string.find(author, ",")

        if i != -1:
            # Looks like last, first
            # Remove , pseud if present.
            if (string.count(author, ",") > 1):
                i = string.find(author, ",")
                i = string.find(author, ",", i+1)
                author = author[0:i]

            # Remove trailing period, if present
            i = string.rfind(author, ".")

            if (i != -1):
                x = i - 2

                if (x >= 2):
                    if (author[x:x+1] != ' '):
                        if (len(author) == (i + 1)):
                            author = author[0:i]
                else:
                    if (len(author) == (i + 1)):
                        author = author[0:i]

            if author[len(author) - 1] == ",":
                author = author[0: len(author)-1]

            authorList.append(rw.convertName(author))

    rw.setAuthors(authorList)


    # Find Title
    title = searchForPlus(source, ">Main title<")
    title = searchForPlus(title, "<td")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    i = string.find(title, " / ")

    if i != -1:
        title = stripText(title[0:i])

    # Remove Translated by, if present.
    i = string.find(title, ". Translated")

    if (i != -1):
        title = title[0:i]

    # Remove trailing period, if present
    if title.endswith(".") == 1:
        title = title[0:len(title)-1]

    rw.setTitle(title)


    # Find Place
    i = string.find(source, ">Published/")

    if i != -1:
        attrs = searchForPlus(source, ">Published/")
        attrs = searchForPlus(attrs, "<td")
        attrs = searchForPlus(attrs, ">")
        i = string.find(attrs, "<")
        attrs = stripText(attrs[0:i])
        i = string.find(attrs, " : ")

        if i != -1:
            rw.setPublicationPlace(stripText(attrs[0:i]))
            attrs = stripText(attrs[i+2:])
        else:
            i = string.find(attrs, "., ")

            if i != -1:
                rw.setPublicationPlace(stripText(attrs[0:i+1]))
                attrs = stripText(attrs[i+2:])
            else:
                i = string.find(attrs, ", ")

                if i != -1:
                    rw.setPublicationPlace(stripText(attrs[0:i]))
                    attrs = stripText(attrs[i+1:])


        # Find Publisher
        i = string.rfind(attrs, ",")

        if i != -1:
            rw.setPublisher(stripText(attrs[0:i]))
            attrs = stripText(attrs[i+1:])
        else:
            i = string.rfind(attrs, "[")

            if i != -1:
                rw.setPublisher(stripText(attrs[0:i]))
                attrs = stripText(attrs[i+1:])
            else:
                rw.setPublisher(attrs)


        # Find Publication Date
        i = string.find(attrs, ".")

        if i != -1:
            date = stripText(attrs[0:i])
        else:
            date = attrs

        i = string.find(date, "[")

        if i != -1:
            date = stripText(date[i+1:])

        i = string.find(date, "]")

        if i != -1:
            date = stripText(date[0:i])

        # if date in format cyyyy, strip c
        if (len(date) == 5):
            i = string.find(date, "c")

            if i == 0:
                date = stripText(date[1:])
                rw.setCopyrightDate(date)
        
        rw.setReleaseDate(date)


    # Find Pages
    i = string.find(source, ">Description<")

    if i != -1:
        attrs = searchForPlus(source, ">Description<")
        attrs = searchForPlus(attrs, "<span")
        attrs = searchForPlus(attrs, ">")
        i = string.find(attrs, "<")
        attrs = stripText(attrs[0:i])
        i = string.find(attrs, "p.")

        if i != -1:
            pages = stripText(attrs[0:i])

            i = string.rfind(pages, " ")

            if i != -1:
                pages = stripText(pages[i:])

            rw.setPages(pages)


        # Find Dimensions
        dimensions = attrs
        i = string.find(dimensions, " cm.")

        if i != -1:
            dimensions = stripText(dimensions[i-5: i+4:])

        i = string.find(dimensions, " ")

        if i != -1:
            dimensions = stripText(dimensions[i:])

        i = string.find(dimensions, ";")

        if i != -1:
            dimensions = stripText(dimensions[i+1:])

        if dimensions == "cm.":
            dimensions = ""

        rw.setDimensions(dimensions)


    # Find ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN<")
        isbn = searchForPlus(isbn, "<span")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        # Find format (only look for paperback)
        if string.find(isbn, "pbk") != -1:
            rw.setFormat("Paperback")
        elif string.find(isbn, "paper") != -1:
            rw.setFormat("Paperback")
        else:
            rw.setFormat("Hardcover")

        i = string.find(isbn, " ")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find LOC Call Number
    i = string.find(source, ">LC classification")

    if i != -1:
        callNumber = searchForPlus(source, ">LC classification")
        callNumber = searchForPlus(callNumber, "<span")
        callNumber = searchForPlus(callNumber, ">")
        i = string.find(callNumber, "<")
        callNumber = stripText(callNumber[0:i])
        rw.setCallNumber(callNumber)


    # Find Comments
    comments = ""
    i = string.find(source, ">Notes<")

    if i != -1:
        comment = searchForPlus(source, ">Notes<")
        comment = searchForPlus(comment, "<span")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)


    # Find Comments
    i = string.find(source, ">Summary<")

    if i != -1:
        comment = searchForPlus(source, ">Summary<")
        comment = searchForPlus(comment, "<span")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)


    # Find Comments
    i = string.find(source, ">Contents<")

    if i != -1:
        comment = searchForPlus(source, ">Contents<")
        comment = searchForPlus(comment, "<span")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    if comments != "":
        rw.setProductInfo(comments)


    # Find Keywords
    i = string.find(source, ">Subjects<")

    if i != -1:
        temp = searchForPlus(source, ">Subjects<")
        i = string.find(temp, "</ul>")
        temp = stripText(temp[0:i])
        keywords = ""

        while (searchFor(temp, "href=\"") != None):
            temp = searchForPlus(temp, "href=\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])
            i = string.rfind(keyword, ".")

            if (i != -1):
                keyword = stripText(keyword[0:i])

            if keywords != "":
                keywords = keywords + ", " + keyword
            else:
                keywords = keyword

        rw.setKeywords(keywords)


    # Find Category
    i = string.find(source, ">Form/Genre<")

    if i != -1:
        cat = searchForPlus(source, ">Form/Genre<")
        cat = searchForPlus(cat, "href=\"")
        cat = searchForPlus(cat, ">")
        i = string.find(cat, "<")
        cat = stripText(cat[0:i])

        i = string.rfind(cat, ".")

        if i != -1:
            cat = stripText(cat[0:i])
            
        rw.setCategory1(cat)
    else:
        i = string.find(source, ">Subjects<")

        if i != -1:
            cats = searchForPlus(source, ">Subjects<")
            i = string.find(cats, "</ul>")
            cats = stripText(cats[0:i])
            ccount = 1

            while (searchFor(cats, "href=\"") != None):
                cats = searchForPlus(cats, "href=\"")
                cats = searchForPlus(cats, ">")
                i = string.find(cats, "<")
                cat = stripText(cats[0:i])
                i = string.rfind(cat, ".")

                if i != -1:
                    cat = stripText(cat[0:i])

                if ccount == 1:
                    rw.setCategory1(cat)
                elif ccount == 2:
                    rw.setCategory2(cat)
                else:
                    rw.setCategory3(cat)
                    break

                ccount = ccount + 1


    # Find Series
    i = string.find(source, ">Series<")

    if i != -1:
        series = searchForPlus(source, ">Series<")
        series = searchForPlus(series, "href=\"")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find LCCN
    i = string.find(source, ">LC control no.<")

    if i != -1:
        lccn = searchForPlus(source, ">LC control no.<")
        lccn = searchForPlus(lccn, "<span")
        lccn = searchForPlus(lccn, ">")
        i = string.find(lccn, "<")
        lccn = stripText(lccn[0:i])
        rw.setLCCN(lccn)


    # Find Dewey Number
    i = string.find(source, ">Dewey class no.<")

    if i != -1:
        source = searchForPlus(source, ">Dewey class no.<")
        source = searchForPlus(source, "<span")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        rw.setDewey(stripText(source[0:i]))







try:
    rw.setBookObject(Book)

    i = string.find(source, ">Library of Congress LCCN Permalink for")

    if i == -1:
        # LOC search results page
        print "SEARCH RESULTS"
        extract(source)
    else:
        print "LCCN PERMALINK"
        extractPL(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
