# Amazon DE video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("")


    i = string.find(source, "sai-identify")

    if i != -1:
        source = searchForPlus(source, "sai-identify")
        i = string.find(source, "/ASIN/")
        source = source[i-50:]
        source = searchForPlus(source, "<a href=")
        i = string.find(source, ">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, ">Please verify that this is the")

    if i != -1:
        source = searchForPlus(source, ">Please verify that this is the")
        source = searchForPlus(source, "class=\"headerblocktitle\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "id=\"result_0\"")

    if i != -1:
        source = searchForPlus(source, "id=\"result_0\"")
        source = searchForPlus(source, "<a href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "ineligible for Amazon.de Marketplace selling.")

    if (i != -1):
        # Not found
        return;


    # Find List price
    i = string.find(source, ">Statt:")

    if (i != -1):
        listprice = searchForPlus(source, ">Statt:")
        listprice = searchFor(listprice, "EUR")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    i = string.find(source, ">From Our Marketplace Sellers:<")

    if (i != -1):
        source = searchForPlus(source, ">From Our Marketplace Sellers:<")


    # Find New
    i = string.find(source, "sdp_new")

    if (i != -1):
        usedinfo = searchForPlus(source, "sdp_new")
        usedinfo = searchForPlus(usedinfo, ">")
        i = string.find(usedinfo, "<br>")
        usedinfo = stripText(usedinfo[0:i])

        i = string.find(usedinfo, "new<")

        if (i != -1):
            i = string.find(usedinfo, "new<")
            newcount = stripText(usedinfo[0:i])

            usedinfo = searchForPlus(usedinfo, "new<")
            usedinfo = searchFor(usedinfo, ">")
            usedinfo = searchForPlus(usedinfo, ">")
            i = string.find(usedinfo, "<")
            newprice = stripText(usedinfo[0:i])


    # Find Collectible
    i = string.find(source, "sdp_coll")

    if (i != -1):
        usedinfo = searchForPlus(source, "sdp_coll")
        usedinfo = searchForPlus(usedinfo, ">")
        i = string.find(usedinfo, "<br>")
        usedinfo = stripText(usedinfo[0:i])

        i = string.find(usedinfo, "collectable<")

        if (i != -1):
            i = string.find(usedinfo, "collectable<")
            collectiblecount = stripText(usedinfo[0:i])

            usedinfo = searchForPlus(usedinfo, "collectable<")
            usedinfo = searchFor(usedinfo, ">")
            usedinfo = searchForPlus(usedinfo, ">")
            i = string.find(usedinfo, "<")
            collectibleprice = stripText(usedinfo[0:i])


    # Find Used
    i = string.find(source, "sdp_used")

    if (i != -1):
        usedinfo = searchForPlus(source, "sdp_used")
        usedinfo = searchForPlus(usedinfo, ">")
        i = string.find(usedinfo, "<br>")
        usedinfo = stripText(usedinfo[0:i])

        i = string.find(usedinfo, "used<")

        if (i != -1):
            i = string.find(usedinfo, "used<")
            usedcount = stripText(usedinfo[0:i])

            try:
                usedinfo = searchForPlus(usedinfo, "used<")
                usedinfo = searchFor(usedinfo, ">")
                usedinfo = searchForPlus(usedinfo, ">")
                i = string.find(usedinfo, "<")
                usedprice = stripText(usedinfo[0:i])
            except:
                usedprice = ""


    # Find Ranking
    salesrank = ""
    i = string.find(source, ">Amazon.de Verkaufsrang:")

    if (i != -1):
        usedinfo = searchForPlus(source, ">Amazon.de Verkaufsrang:")
        usedinfo = searchForPlus(usedinfo, "> Nr. ")
        i = string.find(usedinfo, "in DVD")
        salesrank = stripText(usedinfo[0:i])


    # Find Buyer Waiting
    i = string.find(source, "buyer waiting!")

    if (i != -1):
        buyerwaiting = "Y"


    # Find Image
    imageFound = 0
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                vw.setImage1(image)
            else:
                vw.setImage1(image)

            imageFound = 1
    else:
        i = string.find(source, "id=\"prodImageCell\"")

        if i != -1:
            images = searchForPlus(source, "id=\"prodImageCell\"")
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "videogames/ratings")

            if i != -1:
                image = "no-image"

            i = string.find(image, "no-image")

            if i == -1:
                i = string.find(image, "_AA")

                if i != -1:
                    j = string.find(image, "_.")
                    large = stripText(image[0:i] + image[j:])
                    vw.setLargeImage1(large)
                    image = stripText(image[0:i] + "_SL280" + image[j:])
                    vw.setImage1(image)
                else:
                    vw.setImage1(image)

                imageFound = 1


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"rwImages_hidden\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                vw.setImage1(image)

            i = string.find(image, "_SY300_")

            if i != -1:
                large = string.replace(image, "_SY300_", "_SY500_")
                vw.setLargeImage1(large)
                vw.setImage1(image)
            else:
                vw.setImage1(image)

            imageFound = 1

    if vw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)

                imageFound = 1


    if imageFound == 0:                    
        tag = "'colorImages'"

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(images, "\n")
            images = stripText(images[0:i])
            i = string.find(images, "\"main\"")

            if i != -1:
                images = searchForPlus(images, "\"main\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                vw.setImage1(image)

                i = string.rfind(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                vw.setLargeImage1(image)
                imageFound = 1


    # Find Title
    tag = "id=\"btAsinTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"productTitle\""
    
    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, "[Blu-ray]")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Copyright date
    copyDate = ""
    i = string.find(source, ">Produktionsjahr:")

    if (i != -1):
        usedinfo = searchForPlus(source, ">Produktionsjahr:")
        usedinfo = searchForPlus(usedinfo, "> ")
        i = string.find(usedinfo, "<")
        copyDate = stripText(usedinfo[0:i])
        vw.setCopyrightDate(copyDate)


    # Find & Extract Languages (max 6)
    lang = ""
    i = string.find(source, ">Sprache:")

    if (i != -1):
        usedinfo = searchForPlus(source, ">Sprache:<")
        usedinfo = searchForPlus(usedinfo, "> ")
        i = string.find(usedinfo, " (")
        lang = stripText(usedinfo[0:i])
        i = string.find(usedinfo, "</li>")
        usedinfo = stripText(usedinfo[0:i])
        if (string.find(usedinfo, "), ") != -1):
            usedinfo = searchForPlus(usedinfo, ")")
            i = string.find(usedinfo, " (")
            lang = lang + stripText(usedinfo[0:i])
        if (string.find(usedinfo, "), ") != -1):
            usedinfo = searchForPlus(usedinfo, ")")
            i = string.find(usedinfo, " (")
            lang = lang + stripText(usedinfo[0:i])
        if (string.find(usedinfo, "), ") != -1):
            usedinfo = searchForPlus(usedinfo, ")")
            i = string.find(usedinfo, " (")
            lang = lang + stripText(usedinfo[0:i])
        if (string.find(usedinfo, "), ") != -1):
            usedinfo = searchForPlus(usedinfo, ")")
            i = string.find(usedinfo, " (")
            lang = lang + stripText(usedinfo[0:i])
        if (string.find(usedinfo, "), ") != -1):
            usedinfo = searchForPlus(usedinfo, ")")
            i = string.find(usedinfo, " (")
            lang = lang + stripText(usedinfo[0:i])

    #user1 = lang


    # Find & Extract Subtitles
    subt = "Keine Angabe"
    i = string.find(source, ">Untertitel:")

    if (i != -1):
        usedinfo = searchForPlus(source, ">Untertitel:<")
        usedinfo = searchForPlus(usedinfo, "> ")
        i = string.find(usedinfo, "</li>")
        subt = stripText(usedinfo[0:i])

    #user2 = subt


    # Find & Extract Regioncode
    region = "Keine Angabe"
    i = string.find(source, ">Region:")

    if (i != -1):
        usedinfo = searchForPlus(source, ">Region:<")
        usedinfo = searchForPlus(usedinfo, "> ")
        i = string.find(usedinfo, "</li>")
        region = stripText(usedinfo[0:i])
        vw.setRegion(region)


    # Find Image
    if image == "":
        tag = "images.amazon.com"
        i = string.find(source, tag)

        if i == -1 or i > 3000:
            tag = "images-amazon.com/"
            i = string.find(source, tag)

        if i != -1 and i < 3000:
            image = source[i-50:]
            image = searchForPlus(image, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            image = string.replace(image, ".LZZZ", ".MZZZ")

            i = string.find(image, "ZZZ")

            if i == -1:
                image = ""

            i = string.find(image, "dvd-")

            if i != -1:
                image = ""

            i = string.find(image, "truck-icon")

            if i == -1:
                vw.setImage1(image)



    # Find Price
    i = string.find(source, ">Jetzt:")

    if (i == -1):
        i = string.find(source, ">Amazon-Preis:")

    if (i == -1):
        i = string.find(source, "Preis:")

    if (i != -1):
        source = source[i:]

        source = searchFor(source, "EUR")
        i = string.find(source, "<")
        value = stripText(source[0:i])

        # Price can contain special charges, ignore
        i = string.find(value, "+")

        if (i != -1):
            value = stripText(value[0:i])

        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Format
    i = string.find(source, "bxgy_x_title")
    if i != -1:
        format = searchForPlus(source, "bxgy_x_title")
        format = searchForPlus(format, "Dieser Artikel: </strong>")
        format = searchForPlus(format, "<b>")
        i = string.find(format, "</b>")
        format = stripText(format[0:i])
        vw.setFormat(format)


    # Find Rating
    i = string.find(source, ">FSK: <")

    if i != -1:
        mpaa = searchForPlus(source, ">FSK: <")
        mpaa = searchForPlus(mpaa, ">")
        i = string.find(mpaa, "Jahren")
        mpaa = stripText(mpaa[0:i+6])
    else:
        mpaa = "Keine Freigabe"

    vw.setCertification(mpaa)

    # Find Rating 0 years
    i = string.find(source, "Ohne Altersbeschrnkung")

    if i != -1:
        mpaa = "Ohne Altersbeschrnkung"
        vw.setCertification(mpaa)


    # Find Actors
    i = string.find(source, ">Darsteller:")

    if i != -1:
        actors = searchForPlus(source, ">Darsteller:")
        i = string.find(actors, "</li>")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "href=\"") != None):
            actors = searchForPlus(actors, "href=\"")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Regisseur")

    if i != -1:
        director = searchForPlus(source, ">Regisseur")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find Author
    i = string.find(source, ">Buch:<")

    if i != -1:
        author = searchForPlus(source, ">Buch:<")
        author = searchForPlus(author, "href")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])
        vw.setAuthor(author)


    # Find Composer
    i = string.find(source, ">Komponist:<")

    if i != -1:
        composer = searchForPlus(source, ">Komponist:<")
        composer = searchForPlus(composer, ">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])
        vw.setComposer(composer)


    # Find Sound
    tag = "Sprachen:"
    i = string.find(source, tag)
 
    if i == -1:
        tag = "Sprache:"
        i = string.find(source, tag)
 
    if i != -1:
        sound = searchForPlus(source, tag)
        i = string.find(sound, "</li>")
        sound = stripText(sound[0:i])
        sound = searchForPlus(sound, "</b>")
        i = string.find(sound, ",")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


    # Find Closed captioned
    i = string.find(source, "Untertitel:")

    if i != -1:
        vw.setClosedCaptioned("true")


    # Find Release date
    i = string.find(source, ">Erscheinungstermin:<")

    if i != -1:
        date = searchForPlus(source, ">Erscheinungstermin:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find running time
    i = string.find(source, ">Spieldauer:<")

    if i != -1:
        running = searchForPlus(source, ">Spieldauer:<")
        running = searchForPlus(running, ">")
        i = string.find(running, "<")
        running = stripText(running[0:i])
        vw.setRunningTime(running)


    # Find widescreen
    i = string.find(source, ">Bildseitenformat:<")

    if i != -1:
        wide = searchForPlus(source, ">Bildseitenformat:<")
        wide = searchForPlus(wide, ">")
        i = string.find(wide, "<")
        wide = stripText(wide[0:i])

        if wide == "4:3":
            vw.setAspectRatio("Standard")
        else:
            vw.setAspectRatio(wide)



    # Find Studio
    i = string.find(source, ">Studio:<")

    if i != -1:
        studio = searchForPlus(source, ">Studio:<")
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "<")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Comments
    comments = ""
    i = string.find(source, ">Rezensionen<")

    if (i != -1):
        comments = searchForPlus(source, ">Rezensionen<")
        comments = searchForPlus(comments, "<div ")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<hr ")
        comments = comments[0:i]

        i = string.find(comments, "Alle Rezensionen")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<table ")

        if i != -1:
            comments = comments[0:i]

        vw.setProductInfo(comments)


    i = string.find(source, "Produktbeschreibungen")

    if (i != -1):
        reviews = searchForPlus(source, "Produktbeschreibungen")
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<style")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)

        i = string.find(comments, "Special Features:")

        if i != -1:
            if vw.getExtrasInfo() == "":
                vw.setExtrasInfo(comments[i:])

            comments = stripText(comments[0:i])

        vw.setProductInfo(comments)


try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
