# amazon.fr scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 2")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("Franais")
    vw.setCertification("NR")
    vw.setCurrencySymbol("")


    i = string.find(source, "sai-identify")

    if i != -1:
        source = searchForPlus(source, "sai-identify")
        i = string.find(source, "/ASIN/")
        source = source[i-50:]
        source = searchForPlus(source, "<a href=")
        i = string.find(source, ">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "l'article ci-dessous. S'il ne")

    if i != -1:
        source = searchForPlus(source, "l'article ci-dessous. S'il ne")
        source = searchForPlus(source, "class=\"headerblocktitle\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "id=\"result_0\"")

    if i != -1:
        source = searchForPlus(source, "id=\"result_0\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "il ne peut pas tre vendu sur Amazon Marketplace")

    if (i != -1):
        # Not found
        return;


    # Find Format (DVD, VHS)
    i = string.find(source, ">Format:")

    if i != -1:
        format = searchForPlus(source,">Format:")
        format = searchForPlus(format,">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        vw.setFormat(format)
    else:
        i = string.find(source, ">Format\xC2\xA0:")

        if i != -1:
            format = searchForPlus(source,">Format\xC2\xA0:")
            format = searchForPlus(format,"<span>")
            i = string.find(format, "<")
            format = stripText(format[0:i])
            vw.setFormat(format)
        
    

    # Find Image
    tag = "id='imageBlock'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "<li class=\"image")
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                vw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                vw.setLargeImage1(large)
                vw.setImage1(image)
            else:
                vw.setImage1(image)

    if vw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)

    if vw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                vw.setImage1(image)
                vw.setLargeImage1(image)
 

    # Find Price
    tag = "id=\"actualPriceContent\""

    if string.find(source, tag) == -1:
        tag = "id=\"priceblock_ourprice\""

    if string.find(source, tag) == -1:
        tag = "id=\"buyNewSection\""

    i = string.find(source, tag)

    if i != -1:
      value = searchForPlus(source, tag)
      value = searchForPlus(value, "EUR ")
      i = string.find(value, "<")
      value = stripText(value[0:i])     

      vw.setItemValue(value)

      vw.setPurchasePrice(vw.getItemValue())
      vw.setPurchaseDate(Date())
      vw.setPurchasePlace(vw.getSource())
 

    # Find List Price
    tag = "class=\"listprice\""

    if string.find(source, tag) == -1:
        tag = ">Prix conseill"

    i = string.find(source, tag)

    if i != -1:
      value = searchForPlus(source, tag)
      value = searchForPlus(value, "EUR ")
      i = string.find(value, "<")
      value = stripText(value[0:i])     

      vw.setListPrice(value)


    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, "id=\"productTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, "[")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)
    
    i = string.find(source, "tails sur le produit")
    if i != -1:
        source = searchForPlus(source, "tails sur le produit")
    
    # Find Actors
    tag = '>Acteurs'
    i = string.find(source, tag)
    if i != -1:
        source = searchForPlus(source, tag)
        i = string.find(source, "</li>")
        actors = stripText(source[0:i] + ">, <")

        while (searchFor(actors, ", ") != None):
            i = string.find(actors, "<a href")

            if i != -1:
                actors = searchForPlus(actors, "<a href")
                actors = searchForPlus(actors, ">")
                i = string.find(actors, "<")
                actor = stripText(actors[0:i])

                vw.setActor(actor)

            actors = searchForPlus(actors, ", ")

            
        source = searchForPlus(source, "</li>")


    # Find Director
    tag = ">Réalisateurs"
    i = string.find(source, tag)
    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "<a href")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        director = stripText(source[0:i])
        vw.setDirector(director)
    

    #Find Region
    tag = "gion&nbsp;"
    i = string.find(source, tag)

    if i != -1:
        region = searchForPlus(source, tag)
        region = searchForPlus(region, "</b>")
        i = string.find(region, "</li>")
        region = stripText(region[0:i])

        i = string.find(region, "(")

        if i != -1:
            region = stripText(region[0:i])

        i = string.find(region, " ")

        if i != -1:
            region = stripText(region[i+1:])

        region = "Region " + region
        vw.setRegion(region)

    
    #Find Studio
    tag = ">Studio"
    i = string.find(source, tag)

    if i != -1:
        studio = searchForPlus(source, tag)
        studio = searchForPlus(studio, "</b>")
        i = string.find(studio, "</li>")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)
    

    #Find Date
    tag = ">Date de sortie"
    i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "</b>")
        i = string.find(date, "</li>")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)
    

    #Find Language
    tag = ">Langue"
    i = string.find(source, tag)

    if i != -1:
        language = searchForPlus(source, tag)
        language = searchForPlus(language, "</b>")
        i = string.find(language, "</li>")
        language = stripText(language[0:i])
        vw.setLanguage(language)
    

    #Find Subtitles
    tag = ">Sous-titres"
    i = string.find(source, tag)

    if i != -1:
        subtitles = searchForPlus(source, tag)
        subtitles = searchForPlus(subtitles, "</b>")
        i = string.find(subtitles, "</li>")
        subtitles = stripText(subtitles[0:i])

        if subtitles != None:
            vw.setSubtitled("true")
    

    #Find Aspect Ratio
    tag = ">Rapport de forme"
    i = string.find(source, tag)

    if i != -1:
        aspect = searchForPlus(source, tag)
        aspect = searchForPlus(aspect, "</b>")
        i = string.find(aspect, "</li>")
        aspect = stripText(aspect[0:i])

        if aspect == "1.33:1":
            aspect = "Standard"
        else:
            aspect = "Widescreen " + aspect

        vw.setAspectRatio(aspect)
    

    #Find Running Time
    tag = ">Dure"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Dur\xC3\xA9e"
        i = string.find(source, tag)

    if i != -1:
        time = searchForPlus(source, tag)
        time = searchForPlus(time, "</b>")
        i = string.find(time, "</li>")
        time = stripText(time[0:i])
        vw.setRunningTime(time)
    

    #Find ASIN
    tag = ">ASIN:"
    i = string.find(source, tag)

    if i != -1:
        asin = searchForPlus(source, tag)
        asin = searchForPlus(asin, "</b>")
        i = string.find(asin, "</li>")
        asin = stripText(asin[0:i])
        vw.setASIN(asin)
    

    #Find Sales Rank
    tag = ">Classement des meilleures ventes d'Amazon:"
    i = string.find(source, tag)

    if i != -1:
        rank = searchForPlus(source, tag)
        rank = searchForPlus(rank, "</b>")
        i = string.find(rank, "</li>")
        rank = stripText(rank[0:i])

        i = string.find(rank, " ")

        if i != -1:
            rank = stripText(rank[0:i])

        rank = string.replace(rank, ".", "")
        rank = string.replace(rank, ",", "")

        vw.setSalesRank(rank)
    

    #Find Category
    tag = ">Rechercher des articles similaires par rubrique"
    i = string.find(source, tag)

    if i != -1:
        catl = searchForPlus(source, tag)
        catl = searchForPlus(catl, "<ul>")
        catl = searchForPlus(catl, "<li>")
        i = string.find(catl, "</li>")
        catl = stripText(catl[0:i])
        ccount = 1

        while (searchFor(catl, "href=\"") != None):
            catl = searchForPlus(catl, "href=\"")
            catl = searchForPlus(catl, "\">")
            i = string.find(catl, "<")
            cat = stripText(catl[0:i])

            if cat == "DVD & Blu-ray":
                continue

            if cat == "Movies & TV":
                continue

            if ccount == 1:
                vw.setCategory1(cat)
            elif ccount == 2:
                vw.setCategory2(cat)
            else:
                vw.setCategory3(cat)
                break

            ccount = ccount + 1
           

    # Find Comments
    tag = ">Descriptions du produit<"
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<hr ")
        comments = comments[0:i]

        i = string.find(comments, "</form>")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<script")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "Voir l'ensemble des Descriptions du produit")

        if i != -1:
            comments = comments[0:i]

        comments = string.replace(comments, "&#xC9;", "")
        comments = string.replace(comments, "&#xF4;", "")
        vw.setProductInfo(comments)


try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
