# Amazon past purchases video list scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    jarray import zeros, array
from    java.lang import String


def extract():
    global itemNames,itemLinks
    global source
    global names,links

    names = []
    links = []

    i = string.find(source, "> Your Orders<")

    if i == -1:
        return

    # Create trace files
    t2 = open(vw.getLogsDir() + "trace2.html", "w")
    t2.write("Orders by year\n\n")
    t2.close()

    t3 = open(vw.getLogsDir() + "trace3.html", "w")
    t3.write("Individiual orders\n\n")
    t3.close()


    url = searchForPlus(source, "\"order-dropdown-form\"")
    url = searchForPlus(url, "action=\"")
    i = string.find(url, "\"")
    url = "http://www.amazon.com" + stripText(url[0:i]) + "/?POST=?opt=ab&groupID=0&orderFilter="

    years = searchForPlus(source, "\"orderFilter\"")
    i = string.find(years, "</select>")
    years = stripText(years[0:i])

    # Loop through years to get orders per year
    while (searchFor(years, "value=\"year-") != None):
        years = searchFor(years, "value=\"year-")
        years = searchForPlus(years, "\"")
        
        i = string.find(years, "\"")
        orderFilter = stripText(years[0:i])

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        year = http.getContents(url + orderFilter)

        t2 = open(vw.getLogsDir() + "trace2.html", "a")
        t2.write(year)
        t2.close()

        # Loop through this year to get individual orders
        orderCount = 0

        while (searchFor(year, ">View Order Details<") != None):
            i = string.find(year, ">View Order Details<")
            orders = stripText(year[i-250:])
            orders = searchForPlus(orders, "href=\"")

            year = searchForPlus(year, ">View Order Details<")

            i = string.find(orders, "\"")
            orders = stripText(orders[0:i])

            if orders.startswith("http") == 1:
                # z-shop, can't get those
                continue

            orders = "http://www.amazon.com" + orders
            orders = string.replace(orders, "&amp;", "&")

            print "GETTING: ", orders
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            order = http.getContents(orders)
            errorCount = 0

            t3 = open(vw.getLogsDir() + "trace3.html", "a")
            t3.write(order)
            t3.close()

            while (searchFor(order, "<title>We're sorry!</title>") != None):
                # Amazon sometimes has an internal error when fetching the order,
                # try a few times it should clear up.
                print "Amazon internal error encountered"
                errorCount = errorCount + 1

                if errorCount > 5:
                    break

                http.blockForLoad();
                order = http.getContents(orders)

                t3 = open(vw.getLogsDir() + "trace3.html", "a")
                t3.write("Amazon internal error encountered")
                t3.write(order)
                t3.close()

            while (searchFor(order, "Order Placed:") == None):
                # Amazon sometimes displays an empty order list
                # try a few times it should clear up.
                print "Amazon empty order list encountered"
                errorCount = errorCount + 1

                if errorCount > 5:
                    break

                http.blockForLoad();
                order = http.getContents(orders)

                t3 = open(vw.getLogsDir() + "trace3.html", "a")
                t3.write("Amazon empty order encountered")
                t3.write(order)
                t3.close()

            if errorCount > 5:
                continue;

            print "EXTRACTING: ", orders
            extractOrder(order)

            if string.find(year, ">View Order Details<") == -1:
                print "No more orders on page, OC=", orderCount
                orderCount = orderCount + 10
                # Last order on this page, check for more pages
                tag = "startAtIndex=%d" % (orderCount, )
                i = string.find(year, tag)
                print "Looking for ", tag

                if i != -1:
                    print "Found ", tag
                    i = string.find(year, tag)
                    next = stripText(year[i-100:])
                    next = searchForPlus(next, "href=\"")
                    i = string.find(next, "\"")
                    next = stripText(next[0:i])
                    next = string.replace(next, "&amp;", "&")

                    http = HTTPConnection()
                    http.resetReferer();
                    http.blockForLoad();
                    year = http.getContents("http://www.amazon.com" + next)

                    t2 = open(vw.getLogsDir() + "trace2.html", "a")
                    t2.write(year)
                    t2.close()
                else:
                    break

    itemNames = array(names, String)
    itemLinks = array(links, String)



def extractOrder(order):
    global names,links

    i = string.find(order, "order number:")

    if i == -1:
        return;

    order = searchForPlus(order, "order number:")
    i = string.find(order, ">Need Help?<")
    order = stripText(order[0:i])

    # Find item names/links
    while (searchFor(order, "/gp/product/") != None):
        i = string.find(order, "/gp/product/")
        order = stripText(order[i-50:])

        link = searchForPlus(order, "href=\"")
        i = string.find(link, "\"")
        link = stripText(link[0:i])

        name = searchForPlus(order, "href=\"")
        name = searchForPlus(name, ">")
        i = string.find(name, "<")
        name = stripText(name[0:i])
        print "FOUND: ", name

        format = searchForPlus(order, "href=\"")
        format = searchForPlus(format, ">")
        format = searchForPlus(format, "<")

        i = string.find(format, "[")

        if i != -1 and i < 50:
            format = searchForPlus(format, "[")
            i = string.find(format, "]")
            format = stripText(format[0:i])
            print "FOUND: ", name,"-",format

            if format == "DVD" or format == "VHS Tape" or format == "Blu-ray" or format == "HD DVD":
                print "SELECTED: ", name,"-",format
                links.append(link)
                names.append(name)

        order = searchForPlus(order, "/gp/product/")
        




try:
    vw.setVideoObject(Video)
    extract()
finally:
    pass
